<template lang="pug">
  .issuelist
    b-table(
      :data="items"
      custom-row-key="id"
      :row-class="rowClass"
      hoverable
      :loading="isLoading"
      @click="gotoDetail"

      backend-pagination
      :paginated="true"
      :per-page="itemPerPage"
      :pagination-simple="true"
      :pagination-position="pagePosition"
      :total="curTotal"
      @page-change="onPageChange"

      backend-sorting
      sort-icon-size="is-small"
      sort-icon="caret-up"
      :default-sort="[sortField, sortOrder]"
      @sort="onSort"
    )
      template(slot-scope="props")
        b-table-column(field="state" label="進度" sortable searchable)
          state-tag.issuelist__tag(:value="props.row.state")
        b-table-column(field="buildingId" label="公寓" sortable searchable)
          | {{zh(props.row.buildingId)}}
        b-table-column(field="taskType" label="分類" sortable searchable)
          | {{zh(props.row.taskType)}}
        b-table-column(field="reporter" label="通報人" searchable)
          | {{props.row.reporter}}
        b-table-column(field="content" label="緣由" searchable)
          .issuelist__reason.truncate {{props.row.content}}
        b-table-column(field="owner" label="負責人")
          | {{props.row.owner || '-'}}
        b-table-column(field="reportedAt" label="通報日期" sortable)
          | {{createdAt(props.row)}}
        b-table-column(field="atUpdatedAt" label="最後更新" sortable)
          | {{fromNow(props.row.atUpdatedAt)}}
</template>
<script>
import moment from 'moment'
import { issue } from '~/utils/api'
import { issueMixin } from '~/utils/mixins'
import StateTag from '~/components/StateTag'

// 7 days
const TOO_LONG_AGO = 7

export default {
  components: {
    StateTag
  },
  mixins: [issueMixin],
  props: {
    query: {
      type: Object,
      default () {
        return {}
      }
    },
    itemPerPage: {
      type: Number,
      default: 30
    },
    showTopPager: {
      type: Boolean,
      default: true
    }
  },
  data () {
    return {
      items: [],
      curPage: 1,
      curTotal: 0,
      sortField: 'atUpdatedAt',
      sortOrder: 'desc',
      isLoading: true
    }
  },
  computed: {
    pagePosition () {
      if (this.showTopPager) {
        return 'both'
      }
      return 'bottom'
    }
  },
  mounted () {
    this.loadData()
  },
  methods: {
    async loadData () {
      this.isLoading = true
      const sortOrder = this.sortOrder === 'desc' ? -1 : 1
      const resp = await issue.find({
        ...this.query,
        $limit: this.itemPerPage,
        $skip: (this.curPage - 1) * this.itemPerPage,
        $sort: {
          [this.sortField]: sortOrder
        }
      })
      this.items = resp.data
      this.curTotal = resp.total
      this.isLoading = false
    },
    onPageChange (page) {
      this.curPage = page
      this.loadData()
    },
    onSort (field, order) {
      this.sortField = field
      this.sortOrder = order
      this.loadData()
    },
    fromNow (field) {
      return moment(field).fromNow()
    },
    createdAt (row) {
      const theDay = moment(row.reportedAt)
      if (theDay.clone().add(TOO_LONG_AGO, 'days') < moment()) {
        return theDay.format('YYYY-MM-DD')
      }
      return theDay.fromNow()
    },
    rowClass (row) {
      if (!row.state || row.state === '未指派') {
        return 'is-undone'
      }
    },
    gotoDetail (issue) {
      this.$router.push({
        name: 'item-ticketId',
        params: {
          ticketId: issue.id
        }
      })
    }
  }
}
</script>
<style lang="scss" scoped>
.issuelist {
  &__reason {
    max-width: calc(100vw - 70rem);
    width: calc(100vw - 10rem);
  }
  &__tag.state-tag {
    max-width: 5.5rem;
    width: 100%;
  }

  /deep/ {
    table {
      th:nth-child(-n + 4) .th-wrap input {
        width: 4rem;
      }
      thead tr:nth-child(2) {
        th {
          padding: 0.3rem 0.5rem;
        }
        th .th-wrap input {
          font-size: 0.8rem;
          line-height: 1;
          padding: 0.2rem;
        }
      }

      tbody tr {
        font-size: 0.8rem;
        cursor: pointer;
      }

      tr.is-undone {
        background: #FFFCEB;
        td {
          font-weight: bold;
        }
      }
    }
  }
}
</style>
